/***********************************************************
Will Glass
gravity.cpp
AP computer Science
input: NUmber of crew members, nimber of passengers, weight of the clost contents, baggage weight, fuel in gallons.
output: total weight, center of gravity
***********************************************************/

#include <iostream.h>
#include <iomanip.h>

const double PERSON_WT =170.0;
const double LBS_PER_GAL =6.7;
const double EMPTY_WEIGHT = 9887.0;
const double EMPTY_MOMENT = 3153953;

void  GetData(int& numcrew, int& numpass,double& bagwt, double& closwt, double& fuelgal);
double CrewMoment(int numcrew);
double PassengerMoment(int numpass);
double CargoMoment(double bagwt, double closwt);
double FuelMoment(double fuelgal);
void   PrintWarning(const double PERSON_WT, const double LBS_PER_GAL);
double TotWt (int numcrew, int numpass,double bagwt, double closwt, double fuelgal);
double CGrav(double totWt,
			double crewMoment, 
			double passengerMoment, 
			double cargoMoment, 
			double fuelMoment);

int main()
{
	int numcrew, numpass;
	double bagwt, closwt, fuelgal;
	GetData(numcrew, numpass, bagwt, closwt, fuelgal);						//Gets data
	PrintWarning(PERSON_WT, LBS_PER_GAL);
	cout << "\nThe center of gravity is \n" <<
		  CGrav(TotWt(numcrew, numpass, bagwt, closwt, fuelgal),
				CrewMoment(numcrew), 
				PassengerMoment(numpass), 
				CargoMoment(bagwt, closwt), 
				FuelMoment(fuelgal)) <<
		"inches from the front of the plane.\n";
	return 0;
}


void GetData(int& numcrew, int& numpass,double& bagwt, double& closwt, double& fuelgal)
{
	cout << "Please enter the number of crew members: ";
	cin >> numcrew;
	while (numcrew !=1 && numcrew !=2)
	{
		cout << "Invalid entry. There must be one or two crew members. \n Please enter a new value: ";
		cin >> numcrew;
	}
	cout << "Please enter the number of passengers: ";
	cin >> numpass;
	while (numpass >8 || numpass <0)
	{
		cout << "Invalid entry. There must be between 0 and 8 passengers. \n Please enter a new value: ";
		cin >> numpass;
	}
	cout << "Please enter the weight of the baggage: ";
	cin >> bagwt;
	while (bagwt <0)
	{
		cout << "Invalid entry.  Baggage weight cannot be negative. \n Please enter new value: ";
		cin >> bagwt;
	}
	cout << "Please enter the weight of the closet contents: ";
	cin >> closwt;
	while (closwt <0)
	{
		cout << "Invalid entry.  Closet contents weight cannot be negative. \n Please enter new value: ";
		cin >> closwt;
	}
	cout << "Please enter the number of gallons of fuel: ";
	cin >> fuelgal;
	while (fuelgal <=0 || fuelgal >565)
	{
		cout << "Invalid entry.  There must be greater \nthan 0 and no more than 565 gallons of fuel. \n Please enter new value: ";
		cin >> fuelgal;
	}
	cout << "Data entered is as follows: \n\tCrew Members:\t" <<numcrew<< "\n\tPassengers:\t" <<numpass<< "\n\tBaggage Weight:\t" << bagwt<< "\n\tCloset Contents:\t <<closwt<< "\n\tGallons Fuel:/t" <<fuelgal<<endl;
}

/***********************************
Create a function that determines the moment of the crew
	Multiply crew number by 143 and 170
	Return value.
	End this function
************************************/
double CrewMoment(int numcrew)
{
	double cmome= numcrew *143*170;
//	cout << "crewmoment: " << cmome;
	return cmome;
}


//	Create a function that determines the moment of the passengers
double PassengerMoment(int numpass)
{
	double row1mom = 0;				//	Set moments of all rows to zero 
	double row2mom = 0;
	double row3mom = 0;
	double row4mom = 0;
	if (numpass >6)					//If the number of passengers is greater than six
	{
		row4mom = (numpass - 6) * PERSON_WT *341;
									//		Multiply the new passenger number (passengers minus six) by 170 and by 341 to get row 4 moment
		numpass = 6;
									//		Set passengers equal to 6
	}
	if (numpass > 4)				//		If the number of passengers is greater than four
	{
		row3mom = (numpass - 4) * PERSON_WT *295;
									//		Multiply the new passenger number (passengers minus 4) by 170 and by 265 to get row 3 moment
		numpass = 4;
									//		Set passengers equal to 4
	}
	

	if (numpass > 2)				//		If the number of passengers is greater than two
	{
		row1mom = (numpass - 2) * PERSON_WT *219;
									//		Multiply the new passenger number (passengers minus two) by 170 and by 219 to get row 1 moment
		numpass = 2;
									//		Set passengers equal to 2
	}

	row2mom = numpass *PERSON_WT *265;	//		Then multiply the number of passengers by 170 and by 265 to get row 2 moment
//	cout << "passenger moment:" << row1mom + row2mom +row3mom +row4mom;
	return row1mom + row2mom +row3mom +row4mom;
									//		Return row 1 moment + row 2 moment + row 3 momen t+ row 4 moment
}

double CargoMoment(double bagwt, double closwt)
									//		Create a function to determine the moment of the cargo
{
	double closmom, bagmom;
	closmom = closwt * 182;			//		Multiply the weight of the closet contents by 182 to get closet moment
	bagmom = bagwt * 386;			//		Multiply the weight of the baggage by 386 to get baggage moment
//	cout << "cargo moment:" << bagmom+closmom;	
	return bagmom+closmom;			//		Return baggage moment + closet moment
}


double FuelMoment(double fuelgal)	//		Create a function for the moment of the fuel
{
	





	//double tank4 =0, tank3 =0, tank2 = 0, tank1 =0;
	if (fuelgal > 521)				//		If fuel is greater than or equal to 521
	{
		return ((fuelgal-521) * (-.04444) + 323)*LBS_PER_GAL *fuelgal;
									//		Multiply the number of gallons minus 521 by -.04444 and add 323.0 to get tank 4 moment
		//fuelgal =520;				//		Set gallons equal to 520
	}
	else if (fuelgal > 361)				//		If fuel is greater than 361
	{
		return ((fuelgal -361) * (.125) + 303)*LBS_PER_GAL *fuelgal; 
									//		Multiply the number of gallons minus 361 by .12500 and add 303.0 to get tank 3 moment
		//fuelgal = 360;				//		Set gallons equal to 360
	}
	else if (fuelgal > 60)				//		If fuel is greater than 60
	{
		return ((fuelgal -60) * (-.01233) +305.8)*LBS_PER_GAL *fuelgal;
									//		Multiply the number of gallons minus 60 by -.01233 and add 305.8 to get tank 2 moment
		//fuelgal =60;				//		Set gallons equal to 59
	}
	else return fuelgal *314.6 *LBS_PER_GAL *fuelgal;			//		Multiply the number of gallons by 314.6 to get tank on moment
//	cout  << "fuel moment: " << tank1+tank2+tank3+tank4;
	//return tank1+tank2+tank3+tank4;	//		Return tank 1 moment + tank 2 moment + tank 3 moment + tank 4 moment
}
	
void PrintWarning(const double PERSON_WT, const double LBS_PER_GAL)	//	Create Warning function
{
	cout << "\n\tThis Program assumes that passengers fill "
		 << "\n\tthe seat rows in the order 2, 1, 3, 4 and\n\tthat each passenger and crew member weighs\n\t" << PERSON_WT << " pounds. It also assumes that Jet-A fuel\n\tweighs " << LBS_PER_GAL <<" pounds per US gallon.  The center \n\tof gravity calculations for the fuel are \n\tapproximate. If the aircraft is loaded near \n\tits limits, The pilot's operating handbook \n\tshould be used compute weight and center \n\tof gravity with more accuracy.\n";
}
double TotWt(int numcrew, int numpass,double bagwt, double closwt, double fuelgal)	//Create a function for total weight
{
	double totalwt = (numcrew+numpass)*170 + bagwt +closwt +fuelgal*6.7 + EMPTY_WEIGHT;
			//	Add number of crew plus the number of passengers multiplied by 170, the weight of the closet contents, the weight of the baggage, fuel in gallons multiplied by 6.7, and 9887 to get total weight
	if (totalwt !=0)
	{
	cout << "\nThe total weight is " << totalwt<< "lbs.";
		return totalwt;
	}
	else 
		return -1;
}




double CGrav(double totWt,
			double crewMoment, 
			double passengerMoment, 
			double cargoMoment, 
			double fuelMoment)
{
	double totmoment = crewMoment + passengerMoment + cargoMoment + fuelMoment +EMPTY_MOMENT;
		//	Add the moments of the crew, the passengers, the cargo, the fuel and the empty plane to get total moment.
	double centerg = totmoment / totWt;
		//	Return the total moment divided by the total weight
	return centerg;
}
//	End function

/**********************************************
Please enter the number of crew members: 2
Please enter the number of passengers: 8
Please enter the weight of the baggage: 100
Please enter the weight of the closet contents: 100
Please enter the number of gallons of fuel: 565

        This Program assumes that passengers fill
        the seat rows in the order 2, 1, 3, 4 and
        that each passenger and crew member weighs
        170 pounds. It also assumes that Jet-A fuel
        weighs 6.7 pounds per US gallon.  The center
        of gravity calculations for the fuel are
        approximate. If the aircraft is loaded near
        its limits, The pilot's operating handbook
        should be used compute weight and center
        of gravity with more accuracy.

The total weight is 15572.5lbs.
The center of gravity is
235.029inches from the front of the plane.
Press any key to continue
***********************************************
Please enter the number of crew members: 2
Please enter the number of passengers: 6
Please enter the weight of the baggage: 100
Please enter the weight of the closet contents: 100
Please enter the number of gallons of fuel: 520

        This Program assumes that passengers fill
        the seat rows in the order 2, 1, 3, 4 and
        that each passenger and crew member weighs
        170 pounds. It also assumes that Jet-A fuel
        weighs 6.7 pounds per US gallon.  The center
        of gravity calculations for the fuel are
        approximate. If the aircraft is loaded near
        its limits, The pilot's operating handbook
        should be used compute weight and center
        of gravity with more accuracy.

The total weight is 14931lbs.
The center of gravity is
237.341inches from the front of the plane.
Press any key to continue
***********************************************
Please enter the number of crew members: 2
Please enter the number of passengers: 4
Please enter the weight of the baggage: 100
Please enter the weight of the closet contents: 100
Please enter the number of gallons of fuel: 360

        This Program assumes that passengers fill
        the seat rows in the order 2, 1, 3, 4 and
        that each passenger and crew member weighs
        170 pounds. It also assumes that Jet-A fuel
        weighs 6.7 pounds per US gallon.  The center
        of gravity calculations for the fuel are
        approximate. If the aircraft is loaded near
        its limits, The pilot's operating handbook
        should be used compute weight and center
        of gravity with more accuracy.

The total weight is 13519lbs.
The center of gravity is
254.687inches from the front of the plane.
Press any key to continue
***********************************************
Please enter the number of crew members: 2
Please enter the number of passengers: 2
Please enter the weight of the baggage: 100
Please enter the weight of the closet contents: 100
Please enter the number of gallons of fuel: 59

        This Program assumes that passengers fill
        the seat rows in the order 2, 1, 3, 4 and
        that each passenger and crew member weighs
        170 pounds. It also assumes that Jet-A fuel
        weighs 6.7 pounds per US gallon.  The center
        of gravity calculations for the fuel are
        approximate. If the aircraft is loaded near
        its limits, The pilot's operating handbook
        should be used compute weight and center
        of gravity with more accuracy.

The total weight is 11162.3lbs.
The center of gravity is
301.733inches from the front of the plane.
Press any key to continue
***********************************************
Please enter the number of crew members: 2
Please enter the number of passengers: 0
Please enter the weight of the baggage: 0
Please enter the weight of the closet contents: 0
Please enter the number of gallons of fuel: 10

        This Program assumes that passengers fill
        the seat rows in the order 2, 1, 3, 4 and
        that each passenger and crew member weighs
        170 pounds. It also assumes that Jet-A fuel
        weighs 6.7 pounds per US gallon.  The center
        of gravity calculations for the fuel are
        approximate. If the aircraft is loaded near
        its limits, The pilot's operating handbook
        should be used compute weight and center
        of gravity with more accuracy.

The total weight is 10294lbs.
The center of gravity is
311.416inches from the front of the plane.
Press any key to continue
**********************************************/
