/**************************************************************
Will Glass
Testpay.cpp
AP Computer science
Input:	Principal, annualRate, numYears
Output:	monthlyPayment
***********************************************************/

#include <iostream.h>
#include <math.h>
#include <iomanip.h>
#include <fstream.h>

double monthlyPayment ( double principal,
                        double annualRate,
                        int numYears);
void loanSchedule (	double principal, 
					double annualRate,
					int numYears);

void main ()
{
   
    int numYears;         
	double principal, annualRate;

    cout << endl << "Enter the amount borrowed: ";
    cin >> principal;
    cout << "Enter the annual interest rate (as a % of 1.0): ";
    cin >> annualRate;
    cout << "Enter the length of the loan (in years): ";
    cin >> numYears;  
	cout.setf(ios::fixed, ios::floatfield);
	cout << setprecision (2);
	loanSchedule (	principal, 
					annualRate,
					numYears);
	
}

double monthlyPayment ( double principal,
                        double annualRate,
                        int numYears       )
{
	int numMonths = numYears*12;
	double mpr = annualRate / numMonths;
	double mp = mpr *principal / (1 - (1 / pow((1+mpr),numMonths)));
	return mp;
}
void loanSchedule (	double principal, double annualRate, int numYears)
{

	ofstream outFile;
	int month =0;
	double numMonths = numYears * 12;
	double mpr, interestpaid, principalpaid;
	double balance, mp;
	char outFileName[21];
	cout << "Enter output file name: ";
	cin >> outFileName;
	outFile.open(outFileName, ios::noreplace);
	if (!outFile)
		cout << "File " << outFileName << "could not be opened for output";
	else
	{
		outFile << "\tMonth \t Interest Paid\tPrincipal Paid\tRemaining Balance\n";
		balance = principal;
		while (month < numYears *12)
		{
			mp = monthlyPayment(principal,annualRate, numYears);
			mpr = annualRate / numMonths;
			interestpaid =mpr*balance;
			principalpaid = mp-interestpaid;
			balance += -principalpaid;
			month++;
			outFile.setf(ios::fixed, ios::floatfield);
			outFile << setprecision(2);
			outFile.setf(ios::showpoint); 
			
			outFile << setw(10)<< month << setw(15)<< interestpaid << setw(15)<< principalpaid << setw(15)<< balance <<endl;
		}
	outFile.close();
	}
	
}		

/********************************************************

Enter the amount borrowed: 5000
Enter the annual interest rate (as a % of 1.0): .05
Enter the length of the loan (in years): 2
Enter output file name: 5k.txt
Press any key to continue

	Month 	 Interest Paid	Principal Paid	Remaining Balance
         1          10.42         203.39        4796.61
         2           9.99         203.81        4592.81
         3           9.57         204.23        4388.57
         4           9.14         204.66        4183.91
         5           8.72         205.09        3978.83
         6           8.29         205.51        3773.31
         7           7.86         205.94        3567.37
         8           7.43         206.37        3361.00
         9           7.00         206.80        3154.20
        10           6.57         207.23        2946.97
        11           6.14         207.66        2739.31
        12           5.71         208.10        2531.22
        13           5.27         208.53        2322.69
        14           4.84         208.96        2113.72
        15           4.40         209.40        1904.33
        16           3.97         209.83        1694.49
        17           3.53         210.27        1484.22
        18           3.09         210.71        1273.51
        19           2.65         211.15        1062.36
        20           2.21         211.59         850.77
        21           1.77         212.03         638.74
        22           1.33         212.47         426.27
        23           0.89         212.91         213.36
        24           0.44         213.36           0.00

Enter the amount borrowed: 100000
Enter the annual interest rate (as a % of 1.0): .079
Enter the length of the loan (in years): 20
Enter output file name: 100k.txt
Press any key to continue

	Month 	 Interest Paid	Principal Paid	Remaining Balance
         1          32.92         400.49       99599.51
         2          32.78         400.63       99198.88
         3          32.65         400.76       98798.12
         4          32.52         400.89       98397.23
         5          32.39         401.02       97996.21
         6          32.26         401.15       97595.06
         7          32.13         401.29       97193.78
         8          31.99         401.42       96792.36
         9          31.86         401.55       96390.81
        10          31.73         401.68       95989.13
        11          31.60         401.81       95587.31
        12          31.46         401.95       95185.37
        13          31.33         402.08       94783.29
        14          31.20         402.21       94381.08
        15          31.07         402.34       93978.73
        16          30.93         402.48       93576.26
        17          30.80         402.61       93173.65
        18          30.67         402.74       92770.91
        19          30.54         402.87       92368.04
        20          30.40         403.01       91965.03
        21          30.27         403.14       91561.89
        22          30.14         403.27       91158.62
        23          30.01         403.40       90755.22
        24          29.87         403.54       90351.68
        25          29.74         403.67       89948.01
        26          29.61         403.80       89544.21
        27          29.47         403.94       89140.27
        28          29.34         404.07       88736.21
        29          29.21         404.20       88332.01
        30          29.08         404.33       87927.67
        31          28.94         404.47       87523.20
        32          28.81         404.60       87118.60
        33          28.68         404.73       86713.87
        34          28.54         404.87       86309.00
        35          28.41         405.00       85904.00
        36          28.28         405.13       85498.87
        37          28.14         405.27       85093.60
        38          28.01         405.40       84688.20
        39          27.88         405.53       84282.67
        40          27.74         405.67       83877.00
        41          27.61         405.80       83471.20
        42          27.48         405.93       83065.27
        43          27.34         406.07       82659.20
        44          27.21         406.20       82253.00
        45          27.07         406.34       81846.66
        46          26.94         406.47       81440.19
        47          26.81         406.60       81033.59
        48          26.67         406.74       80626.85
        49          26.54         406.87       80219.98
        50          26.41         407.00       79812.98
        51          26.27         407.14       79405.84
        52          26.14         407.27       78998.57
        53          26.00         407.41       78591.16
        54          25.87         407.54       78183.62
        55          25.74         407.67       77775.95
        56          25.60         407.81       77368.14
        57          25.47         407.94       76960.19
        58          25.33         408.08       76552.12
        59          25.20         408.21       76143.90
        60          25.06         408.35       75735.56
        61          24.93         408.48       75327.08
        62          24.80         408.62       74918.46
        63          24.66         408.75       74509.71
        64          24.53         408.88       74100.83
        65          24.39         409.02       73691.81
        66          24.26         409.15       73282.66
        67          24.12         409.29       72873.37
        68          23.99         409.42       72463.95
        69          23.85         409.56       72054.39
        70          23.72         409.69       71644.70
        71          23.58         409.83       71234.87
        72          23.45         409.96       70824.91
        73          23.31         410.10       70414.81
        74          23.18         410.23       70004.58
        75          23.04         410.37       69594.21
        76          22.91         410.50       69183.71
        77          22.77         410.64       68773.07
        78          22.64         410.77       68362.30
        79          22.50         410.91       67951.39
        80          22.37         411.04       67540.35
        81          22.23         411.18       67129.17
        82          22.10         411.31       66717.86
        83          21.96         411.45       66306.41
        84          21.83         411.58       65894.82
        85          21.69         411.72       65483.10
        86          21.55         411.86       65071.25
        87          21.42         411.99       64659.26
        88          21.28         412.13       64247.13
        89          21.15         412.26       63834.87
        90          21.01         412.40       63422.47
        91          20.88         412.53       63009.94
        92          20.74         412.67       62597.27
        93          20.60         412.81       62184.46
        94          20.47         412.94       61771.52
        95          20.33         413.08       61358.44
        96          20.20         413.21       60945.23
        97          20.06         413.35       60531.88
        98          19.93         413.49       60118.40
        99          19.79         413.62       59704.78
       100          19.65         413.76       59291.02
       101          19.52         413.89       58877.12
       102          19.38         414.03       58463.09
       103          19.24         414.17       58048.93
       104          19.11         414.30       57634.63
       105          18.97         414.44       57220.19
       106          18.83         414.58       56805.61
       107          18.70         414.71       56390.90
       108          18.56         414.85       55976.05
       109          18.43         414.98       55561.07
       110          18.29         415.12       55145.95
       111          18.15         415.26       54730.69
       112          18.02         415.39       54315.29
       113          17.88         415.53       53899.76
       114          17.74         415.67       53484.09
       115          17.61         415.81       53068.29
       116          17.47         415.94       52652.35
       117          17.33         416.08       52236.27
       118          17.19         416.22       51820.05
       119          17.06         416.35       51403.70
       120          16.92         416.49       50987.21
       121          16.78         416.63       50570.58
       122          16.65         416.76       50153.82
       123          16.51         416.90       49736.92
       124          16.37         417.04       49319.88
       125          16.23         417.18       48902.70
       126          16.10         417.31       48485.39
       127          15.96         417.45       48067.94
       128          15.82         417.59       47650.35
       129          15.68         417.73       47232.63
       130          15.55         417.86       46814.76
       131          15.41         418.00       46396.76
       132          15.27         418.14       45978.62
       133          15.13         418.28       45560.35
       134          15.00         418.41       45141.94
       135          14.86         418.55       44723.39
       136          14.72         418.69       44304.70
       137          14.58         418.83       43885.87
       138          14.45         418.96       43466.91
       139          14.31         419.10       43047.80
       140          14.17         419.24       42628.56
       141          14.03         419.38       42209.18
       142          13.89         419.52       41789.67
       143          13.76         419.65       41370.01
       144          13.62         419.79       40950.22
       145          13.48         419.93       40530.29
       146          13.34         420.07       40110.22
       147          13.20         420.21       39690.01
       148          13.06         420.35       39269.67
       149          12.93         420.48       38849.18
       150          12.79         420.62       38428.56
       151          12.65         420.76       38007.80
       152          12.51         420.90       37586.90
       153          12.37         421.04       37165.86
       154          12.23         421.18       36744.69
       155          12.10         421.32       36323.37
       156          11.96         421.45       35901.92
       157          11.82         421.59       35480.33
       158          11.68         421.73       35058.59
       159          11.54         421.87       34636.72
       160          11.40         422.01       34214.72
       161          11.26         422.15       33792.57
       162          11.12         422.29       33370.28
       163          10.98         422.43       32947.86
       164          10.85         422.56       32525.29
       165          10.71         422.70       32102.59
       166          10.57         422.84       31679.74
       167          10.43         422.98       31256.76
       168          10.29         423.12       30833.64
       169          10.15         423.26       30410.38
       170          10.01         423.40       29986.98
       171           9.87         423.54       29563.44
       172           9.73         423.68       29139.76
       173           9.59         423.82       28715.94
       174           9.45         423.96       28291.98
       175           9.31         424.10       27867.89
       176           9.17         424.24       27443.65
       177           9.03         424.38       27019.27
       178           8.89         424.52       26594.76
       179           8.75         424.66       26170.10
       180           8.61         424.80       25745.30
       181           8.47         424.94       25320.37
       182           8.33         425.08       24895.29
       183           8.19         425.22       24470.08
       184           8.05         425.36       24044.72
       185           7.91         425.50       23619.23
       186           7.77         425.64       23193.59
       187           7.63         425.78       22767.82
       188           7.49         425.92       22341.90
       189           7.35         426.06       21915.84
       190           7.21         426.20       21489.65
       191           7.07         426.34       21063.31
       192           6.93         426.48       20636.83
       193           6.79         426.62       20210.22
       194           6.65         426.76       19783.46
       195           6.51         426.90       19356.56
       196           6.37         427.04       18929.52
       197           6.23         427.18       18502.34
       198           6.09         427.32       18075.02
       199           5.95         427.46       17647.56
       200           5.81         427.60       17219.96
       201           5.67         427.74       16792.22
       202           5.53         427.88       16364.34
       203           5.39         428.02       15936.31
       204           5.25         428.16       15508.15
       205           5.10         428.31       15079.84
       206           4.96         428.45       14651.40
       207           4.82         428.59       14222.81
       208           4.68         428.73       13794.08
       209           4.54         428.87       13365.21
       210           4.40         429.01       12936.20
       211           4.26         429.15       12507.05
       212           4.12         429.29       12077.75
       213           3.98         429.43       11648.32
       214           3.83         429.58       11218.74
       215           3.69         429.72       10789.03
       216           3.55         429.86       10359.17
       217           3.41         430.00        9929.17
       218           3.27         430.14        9499.03
       219           3.13         430.28        9068.74
       220           2.99         430.43        8638.32
       221           2.84         430.57        8207.75
       222           2.70         430.71        7777.04
       223           2.56         430.85        7346.19
       224           2.42         430.99        6915.20
       225           2.28         431.13        6484.07
       226           2.13         431.28        6052.79
       227           1.99         431.42        5621.37
       228           1.85         431.56        5189.81
       229           1.71         431.70        4758.11
       230           1.57         431.84        4326.27
       231           1.42         431.99        3894.28
       232           1.28         432.13        3462.15
       233           1.14         432.27        3029.88
       234           1.00         432.41        2597.47
       235           0.85         432.56        2164.91
       236           0.71         432.70        1732.22
       237           0.57         432.84        1299.38
       238           0.43         432.98         866.39
       239           0.29         433.13         433.27
       240           0.14         433.27           0.00

Enter the amount borrowed: 1000
Enter the annual interest rate (as a % of 1.0): .15
Enter the length of the loan (in years): 1
Enter output file name: 1k.txt
Press any key to continue

	Month 	 Interest Paid	Principal Paid	Remaining Balance
         1          12.50          77.76         922.24
         2          11.53          78.73         843.51
         3          10.54          79.71         763.80
         4           9.55          80.71         683.09
         5           8.54          81.72         601.37
         6           7.52          82.74         518.63
         7           6.48          83.78         434.85
         8           5.44          84.82         350.03
         9           4.38          85.88         264.14
        10           3.30          86.96         177.19
        11           2.21          88.04          89.14
        12           1.11          89.14          -0.00


********************************************************/